/* YAWN, Yet Another Web Navigator */
/* Copyright (C) 1998, James Troup <james@nocrew.org>
 *                     Lee Willis <lwillis@comp.brad.ac.uk> */

/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdarg.h>
#include <gtk/gtk.h>
#include "utils.h"
#include "cameron.h"

GtkWidget *
cameron_init (void)
{

  GtkWidget *cameron;

  cameron = gtk_entry_new_with_max_length (512);
  gtk_signal_connect (GTK_OBJECT (cameron), "activate",
		      NULL,
		      cameron);
  gtk_entry_set_editable (GTK_ENTRY (cameron), FALSE);
  gtk_entry_set_text (GTK_ENTRY (cameron), "");
  gtk_widget_set_sensitive (cameron, FALSE);

  return cameron;

}

void
cameron_update (GtkWidget *cameron, const char *fmt,...)
{

  /* FIXME: this can be overrun, but vsnprintf does not exist on Solaris 2.5 */
  char status[256];
  va_list args;

  va_start (args, fmt);
  vsprintf (status, fmt, args);
  va_end (args);

  debug (debug_alyson, "cameron: updating to \"%s\"", status);
  gtk_entry_set_text (GTK_ENTRY (cameron), status);
  while (gtk_events_pending())
    gtk_main_iteration();

}
